//include file
#include <pic.h>

//16F84 configuration 
__CONFIG(0x3FF1);

#define PORTBIT(adr, bit)	((unsigned)(&adr)*8+(bit))

static bit LED0 @ PORTBIT(PORTB, 0);
static bit LED1 @ PORTBIT(PORTB, 1);
static bit LED2 @ PORTBIT(PORTB, 2);
static bit LED3 @ PORTBIT(PORTB, 3);
static bit LED4 @ PORTBIT(PORTB, 4);
static bit LED5 @ PORTBIT(PORTB, 5);
static bit LED6 @ PORTBIT(PORTB, 6);
static bit LED7 @ PORTBIT(PORTB, 7);
static bit ROW  @ PORTBIT(PORTA, 1);
static bit COL  @ PORTBIT(PORTA, 0);

unsigned int i;		//for loop pause
unsigned int c;		//for loop event loop
unsigned int loop;	//for loop delay

//pause functions
void pause_1();
void pause_2();

void setcol();
void setrow();
void DrawPacman();
void DrawFace();
void DrawGhost();
void Klackers();

void setcol()
{
  COL = 1;
	COL=0;
	pause_1();
  	
}

void setrow()
{
	COL=0;
	
  ROW = 1;
//	pause_1();
	ROW=0;

}
void clearcol()
{
	PORTB=0b11111111;
	COL=1;
	COL=0;

//	PORTB = 0b11111111;//rightmost is top (0=lit led)
//	setcol();

}
void DrawFace()
{
	
	
	for(loop=0;loop<200;loop++)
	{
	PORTB = 0b10000000;
	setrow();
	PORTB = 0b11000011;//
	setcol();
	clearcol();
	PORTB = 0b01000000;
	setrow();
	clearcol();
	PORTB = 0b10111101;// 
	setcol();
	clearcol();
	PORTB = 0b00100000;
	setrow();
	PORTB = 0b01101010;// 
	setcol();
	clearcol();
	PORTB = 0b00010000;
	setrow();
	PORTB = 0b01011110;// 
	setcol();
	clearcol();
	PORTB = 0b00001000;
	setrow();
	PORTB = 0b01011110;// 
	setcol();
	clearcol();
	PORTB = 0b00000100;
	setrow();
	PORTB = 0b01101010;// 
	setcol();
	clearcol();
	PORTB = 0b00000010;
	setrow();
	PORTB = 0b10111101;// 
	setcol();
	clearcol();
	PORTB = 0b00000001;
	setrow();
 	PORTB = 0b11000011;// 
	setcol();
	clearcol();
	
	
	}
}
//main function
void main(void)
{

	TRISB=0x00;
	TRISA=0x00;
	PORTB = 0b00000000;
	setrow();
	pause_1();
	PORTB= 0b11111111;
	setcol();
	pause_1();
	while(1)
	{
		for(c=0;c<1;c++)
			DrawPacman();
		for(c=0;c<1;c++)
			DrawGhost();
		for(c=0;c<1;c++)
			DrawFace();
		for(c=0;c<2;c++)
			Klackers();	

		
	}

}
/*
void Klackers2()//my original vertical klackers
{


		for(c=0; c<20; c++)
		{
			

			PORTB = ~0b00010001;
			setcol();
			clearcol();
			pause_2();
			PORTB = ~0b00010010;
			setcol();
			clearcol();
			pause_2();
			PORTB = ~0b00010100;
			setcol();
			clearcol();
			pause_2();
			PORTB = ~0b00011000;
			setcol();
			clearcol();
			pause_2();
			PORTB = ~0b00101000;
			setcol();
			pause_2();
			clearcol();
			PORTB = ~0b01001000;
			setcol();
			clearcol();
			pause_2();
			PORTB = ~0b10001000;
			setcol();
			clearcol();
			pause_2();
			PORTB = ~0b01001000;
			setcol();
			clearcol();
			pause_2();
			PORTB = ~0b00101000;
			setcol();
			clearcol();
			pause_2();
			PORTB = ~0b00011000;
			setcol();
			clearcol();
			pause_2();
			PORTB = ~0b00010100;
			setcol();
			clearcol();
			pause_2();
			PORTB = ~0b00010010;
			setcol();
			clearcol();
			pause_2();
			

		}

}
*/	
void Klackers()//horizontal klackers
{
	PORTB = 0b01111111;
	COL=1;
		for(c=0; c<20; c++)
		{
			

			PORTB = 0b00010001;
			setrow();
			pause_2();
			PORTB = 0b00010010;
			setrow();
			pause_2();
			PORTB = 0b00010100;
			setrow();
			pause_2();
			PORTB = 0b00011000;
			setrow();
			pause_2();
			PORTB = 0b00101000;
			setrow();
			pause_2();
			PORTB = 0b01001000;
			setrow();
			pause_2();
			PORTB = 0b10001000;
			setrow();
			pause_2();
			PORTB = 0b01001000;
			setrow();
			pause_2();
			PORTB = 0b00101000;
			setrow();
			pause_2();
			PORTB = 0b00011000;
			setrow();
			pause_2();
			PORTB = 0b00010100;
			setrow();
			pause_2();
			PORTB = 0b00010010;
			setrow();
			pause_2();
			

		}

}
void DrawPacman()
{
	
	for(loop=0;loop<200;loop++)
	{
	PORTB = 0b10000000;
	setrow();
	PORTB = 0b11110011;//
	setcol();
	clearcol();
	PORTB = 0b01000000;
	setrow();
	clearcol();
	PORTB = 0b10110101  ;// 
	setcol();
	clearcol();
	PORTB = 0b00100000;
	setrow();
	PORTB = 0b01010110   ;// 
	setcol();
	clearcol();
	PORTB = 0b00010000;
	setrow();
	PORTB = 0b01100100  ;// 
	setcol();
	clearcol();
	PORTB = 0b00001000;
	setrow();
	PORTB = 0b01110110  ;// 
	setcol();
	clearcol();
	PORTB = 0b00000100;
	setrow();
	PORTB = 0b01111110   ;// 
	setcol();
	clearcol();
	PORTB = 0b00000010;
	setrow();
	PORTB = 0b10111101   ;// 
	setcol();
	clearcol();
	PORTB = 0b00000001;
	setrow();
 	PORTB = 0b11000011;// 
	setcol();
	clearcol();
	
	
	}




}
void DrawGhost()
{

	for(loop=0;loop<200;loop++)
	{
	PORTB = 0b10000000;
	setrow();
	PORTB = 0b000000011;//
	setcol();
	clearcol();
	PORTB = 0b01000000;
	setrow();
	clearcol();
	PORTB = 0b01111101  ;// 
	setcol();
	clearcol();
	PORTB = 0b00100000;
	setrow();
	PORTB = 0b01111010   ;// 
	setcol();
	clearcol();
	PORTB = 0b00010000;
	setrow();
	PORTB = 0b01111110  ;// 
	setcol();
	clearcol();
	PORTB = 0b00001000;
	setrow();
	PORTB = 0b01111110  ;// 
	setcol();
	clearcol();
	PORTB = 0b00000100;
	setrow();
	PORTB = 0b01111010   ;// 
	setcol();
	clearcol();
	PORTB = 0b00000010;
	setrow();
	PORTB = 0b01111101   ;// 
	setcol();
	clearcol();
	PORTB = 0b00000001;
	setrow();
 	PORTB = 0b00000011;// 
	setcol();
	clearcol();
	
	
	}


}

	
void pause_1()
{

	for(i=0; i<200; i++);
};

void pause_2()
{

	for(i=0; i<2000; i++);

};
			

